#include <iostream>
#include <stdlib.h> //Needed for "exit" function

// Include OpenGL header files, so that we can use OpenGL
#ifdef __APPLE__
#include <OpenGL/OpenGL.h>
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

#include "bird.h"

#define MAXFLAPTIMER 19

using namespace std;

void bird::flap() {
	if (flaptimer == MAXFLAPTIMER) { flaptimer -= 1; }
	if (flaptimer == 0) { flaptimer += 1; }
	
	if (flaptimer % 2) { flaptimer += 2; }
	else { flaptimer -= 2; }
	
}

void bird::set_flaptimer(int ft) {
	flaptimer = ft % MAXFLAPTIMER;
}

void bird::draw() {
	glPushMatrix();
    glTranslatef(x, y, z);

	// draw direction vector
//    glBegin(GL_TRIANGLES);
//    	glColor3f(1,0,0);
//    	glVertex3f(0,0,0);
//    	glVertex3f(dx*50, dy*50, dz*50);
//    	glVertex3f(1,1,1);
//    glEnd();
   
	glRotatef(yrot, 0, 1, 0); 
    glRotatef(xrot, 1, 0, 0);
	
	// draw the bird shape
    glBegin(GL_TRIANGLES);
		glColor3f(1,1,1);
		glVertex3f(0, 0, -size);
		glVertex3f(0, 0, size);
		glVertex3f(size, 2 * size * (float)flaptimer / (float)MAXFLAPTIMER, 0);
		glColor3f(0.6,0.6,0.6);
		glVertex3f(0, 0, -size);
		glVertex3f(0, 0, size);
		glVertex3f(-size, 2 * size * (float)flaptimer / (float)MAXFLAPTIMER, 0);
	glEnd();
    glPopMatrix();
}

void bird::draw(float r, float g, float b) {
	glPushMatrix();
    glTranslatef(x, y, z);

	glRotatef(yrot, 0, 1, 0); 
    glRotatef(xrot, 1, 0, 0);
	
	// draw the bird shape
    glBegin(GL_TRIANGLES);
		glColor3f(r,g,b);
		glVertex3f(0, 0, -size);
		glVertex3f(0, 0, size);
		glVertex3f(size, 2 * size * (float)flaptimer / (float)MAXFLAPTIMER, 0);
		glColor3f(r*0.6,g*0.6,b*0.6);
		glVertex3f(0, 0, -size);
		glVertex3f(0, 0, size);
		glVertex3f(-size, 2 * size * (float)flaptimer / (float)MAXFLAPTIMER, 0);
	glEnd();
    glPopMatrix();
}

void bird::drawsphere() {
	glPushMatrix();
	glTranslatef(x, y, z);
	glutSolidSphere(size, 8, 8);
    glPopMatrix();
}